------------------------------------------------------------
--
-- Author	: Gwenhael Goavec-Merou

-- Creation Date : 21/06/2012
-- File		 : periodcounter_debounce.vhd
--
-- Abstract : none for the moment
--
------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

Entity periodcounter_debounce is
	generic (
		NB_CYCLE : natural := 3
	);
	port (
		-- Syscon signals
		reset	: in  std_logic;
		clk		: in  std_logic;

		input_signal : in std_logic;
		rising_signal : out std_logic;
		falling_signal: out std_logic
	);
end entity periodcounter_debounce;

Architecture bhv of periodcounter_debounce is
	signal rising_clean:std_logic;
	signal falling_clean:std_logic;
	signal read_clean : std_logic_vector(NB_CYCLE-2 downto 0);
begin
	rising_signal <= rising_clean;
	falling_signal <= falling_clean;

	debounce_proc : process(clk, reset)
		variable signal_old : std_logic;
	begin
		if reset = '1' then
			read_clean <= (others => '0');
			signal_old := '0';
			rising_clean <= '0';
			falling_clean <= '0';
		elsif rising_edge(clk) then
			rising_clean <= '0';
			falling_clean <= '0';
		end if;
	end process debounce_proc;
	
end architecture bhv;
